Description

有一个n*n的正整数矩阵,要你求一条从第一行第一列的格子到第n行第n列的路,使得你走过的格子里面的数乘起来的值末尾的零的个数最小。输出最小个数。

Input

第一行包括1个数n。

接下来n行每行n个数字。

Output

一个数字表示末尾零最小个数。

Sample Input

3
1 2 3
4 5 6
7 8 9

Sample Output

0

因为都是正数,对这个来说仅仅需统计最少的2或5就可以。相对简单。

#include<cstdio>
#include<cstring>
#include<algorithm>
#include<vector>
#include<string>
#include<iostream>
#include<queue>
#include<cmath>
#include<map>
#include<stack>
#include<bitset>
using namespace std;
#define REPF( i , a , b ) for ( int i = a ; i <= b ; ++ i )
#define REP( i , n ) for ( int i = 0 ; i < n ; ++ i )
#define CLEAR( a , x ) memset ( a , x , sizeof a )
typedef long long LL;
typedef pair<int,int>pil;
const int INF=0x3f3f3f3f;
const int maxn=1010;
int dp[maxn][maxn][2];
int path[maxn][maxn][2];
int mp[maxn][maxn][2];
int n;
void print(int i,int j)
{
if(i==1&&j==1)
return ;
print(path[i][j][0],path[i][j][1]);
if(i-path[i][j][0]==1&&j==path[i][j][1]) printf("%c",'D');
else printf("%c",'R');
}
int main()
{
int x,cnt1,cnt2,temp;
while(~scanf("%d",&n))
{
REPF(i,1,n)
{
REPF(j,1,n)
{
scanf("%d",&x);
cnt1=cnt2=0;temp=x;
while(temp%2==0)
{
temp/=2;
cnt1++;
}
while(x%5==0)
{
x/=5;
cnt2++;
}
mp[i][j][0]=cnt1;
mp[i][j][1]=cnt2;
}
}
CLEAR(dp,INF);
dp[1][1][0]=mp[1][1][0];
dp[1][1][1]=mp[1][1][1];
for(int i=1;i<=n;i++)
{
for(int j=1;j<=n;j++)
{
for(int k=0;k<2;k++)//0:2 1:5
{
if(i>1&&dp[i][j][k]>dp[i-1][j][k]+mp[i][j][k])
{
dp[i][j][k]=dp[i-1][j][k]+mp[i][j][k];
path[i][j][0]=i-1;path[i][j][1]=j;
}
if(j>1&&dp[i][j][k]>dp[i][j-1][k]+mp[i][j][k])
{
dp[i][j][k]=dp[i][j-1][k]+mp[i][j][k];
path[i][j][0]=i;path[i][j][1]=j-1;
}
}
}
}
printf("%d\n",min(dp[n][n][0],dp[n][n][1]));
// print(n,n);
// puts("");
}
return 0;
}
/*

再看Codeforces 2B:

Description

There is a square matrix n × n, consisting of non-negative integer numbers. You should find such a way on it that

  • starts in the upper left cell of the matrix;
  • each following cell is to the right or down from the current cell;
  • the way ends in the bottom right cell.

Moreover, if we multiply together all the numbers along the way, the result should be the least "round". In other words, it should end in the least possible number of zeros.

Input

The first line contains an integer number n (2 ≤ n ≤ 1000), n is
the size of the matrix. Then follow n lines containing the matrix elements (non-negative integer numbers not exceeding109).

Output

In the first line print the least number of trailing zeros. In the second line print the correspondent way itself.

Sample Input

Input
3
1 2 3
4 5 6
7 8 9
Output
0
DDRR

Source

不仅要输出路径。并且矩阵中还带了0,这就是麻烦的地方。

题解:对于要输出的路径。记录前面的一个状态就可以。对于0的处理,假设到终点的2或

5的个数大于等于1了,而矩阵中含0。这时候就是直接答案就是1个0。路径仅仅需找到随意

一个0所在的行列输出就可以。

#include<cstdio>
#include<cstring>
#include<algorithm>
#include<vector>
#include<string>
#include<iostream>
#include<queue>
#include<cmath>
#include<map>
#include<stack>
#include<bitset>
using namespace std;
#define REPF( i , a , b ) for ( int i = a ; i <= b ; ++ i )
#define REP( i , n ) for ( int i = 0 ; i < n ; ++ i )
#define CLEAR( a , x ) memset ( a , x , sizeof a )
typedef long long LL;
typedef pair<int,int>pil;
const int INF=0x3f3f3f3f;
const int maxn=1010;
int dp[maxn][maxn][2];
int path1[maxn][maxn][2];
int path2[maxn][maxn][2];
int mp[maxn][maxn][2];
int n;
void print1(int i,int j)
{
if(i==1&&j==1)
return ;
print1(path1[i][j][0],path1[i][j][1]);
if(i-path1[i][j][0]==1&&j==path1[i][j][1]) printf("%c",'D');
else printf("%c",'R');
}
void print2(int i,int j)
{
if(i==1&&j==1)
return ;
print2(path2[i][j][0],path2[i][j][1]);
if(i-path2[i][j][0]==1&&j==path2[i][j][1]) printf("%c",'D');
else printf("%c",'R');
}
int main()
{
int x,cnt1,cnt2,temp,ans;
int sx,sy;
while(~scanf("%d",&n))
{
int flag=1;
CLEAR(mp,0);
REPF(i,1,n)
{
REPF(j,1,n)
{
scanf("%d",&x);
cnt1=cnt2=0;temp=x;
if(x==0)
{
mp[i][j][0]=mp[i][j][1]=1;
sx=i;sy=j;flag=0;continue;
}
while(temp%2==0)
{
temp/=2;
cnt1++;
}
while(x%5==0)
{
x/=5;
cnt2++;
}
mp[i][j][0]=cnt1;
mp[i][j][1]=cnt2;
}
}
CLEAR(dp,INF);
dp[1][1][0]=mp[1][1][0];
dp[1][1][1]=mp[1][1][1];
for(int i=1;i<=n;i++)
{
for(int j=1;j<=n;j++)
{
for(int k=0;k<2;k++)//0:2 1:5
{
if(i>1&&dp[i][j][k]>dp[i-1][j][k]+mp[i][j][k])
{
dp[i][j][k]=dp[i-1][j][k]+mp[i][j][k];
if(!k)
{
path1[i][j][0]=i-1;
path1[i][j][1]=j;
}
else
{
path2[i][j][0]=i-1;
path2[i][j][1]=j;
}
}
if(j>1&&dp[i][j][k]>dp[i][j-1][k]+mp[i][j][k])
{
dp[i][j][k]=dp[i][j-1][k]+mp[i][j][k];
if(!k)
{
path1[i][j][0]=i;
path1[i][j][1]=j-1;
}
else
{
path2[i][j][0]=i;
path2[i][j][1]=j-1;
}
}
}
}
}
ans=min(dp[n][n][0],dp[n][n][1]);
if(ans>=1&&!flag)
{
printf("%d\n",1);
for(int i=0;i<sx-1;i++)
printf("%c",'D');
for(int i=0;i<sy-1;i++)
printf("%c",'R');
for(int i=sx;i<n;i++)
printf("%c",'D');
for(int i=sy;i<n;i++)
printf("%c",'R');
puts("");
continue;
}
printf("%d\n",ans);
if(ans==dp[n][n][0]) print1(n,n);
else print2(n,n);
puts("");
}
return 0;
}
/*
3
2 2 2
2 2 2
5 5 5
*/

Codeforces #2B The least round way(DP)的更多相关文章

  1. codeforces 2B The least round way(DP+数学)

    The least round way 题目链接:http://codeforces.com/contest/2/problem/B ——每天在线,欢迎留言谈论.PS.本题有什么想法.建议.疑问 欢迎 ...

  2. Codeforces 2B The least round way(dp求最小末尾0)

    题目链接:http://codeforces.com/problemset/problem/2/B 题目大意: 给你一个nxn的矩形,找到一条从左上角到右下角的路径,使得该路径上所有数字的乘积的末尾0 ...

  3. codeforces 2B The least round way 【DP】

    VJ上可找到中文题意. 思路: 首先分解有多少2与多少5.接下来就是dp. 分两次,一次是根据2的数量贪心,另外一次是根据5的数量贪心,看哪一次乘积的末尾0最少. 需要注意的是两点: 1.输入有0的情 ...

  4. Codeforces 2B. The least round way

    There is a square matrix n × n, consisting of non-negative integer numbers. You should find such a w ...

  5. 最小较小codeforces 2B The least round way

    查了好多资料,发现还是不全,干脆自己整理吧,至少保证在我的做法正确的,以免误导读者,也是给自己做个记载吧! 求从左上角到右下角所经过的数字之积末端所含0最小的个数 终究的积可以当作A*2^x*5^y, ...

  6. CF 2B The least round way DP+Math

    题意: 找出一条路, 使每个节点相乘,得到的数末尾 0 最少 每次移动只能向右或者向下, 找到后打印路径 ///按照题目要求,就是找出一条从左上角到右下角中每个数含2 or 5 最少的路 ///可以用 ...

  7. [CodeForces - 1225E]Rock Is Push 【dp】【前缀和】

    [CodeForces - 1225E]Rock Is Push [dp][前缀和] 标签:题解 codeforces题解 dp 前缀和 题目描述 Time limit 2000 ms Memory ...

  8. [Codeforces 865C]Gotta Go Fast(期望dp+二分答案)

    [Codeforces 865C]Gotta Go Fast(期望dp+二分答案) 题面 一个游戏一共有n个关卡,对于第i关,用a[i]时间通过的概率为p[i],用b[i]通过的时间为1-p[i],每 ...

  9. [Codeforces 553E]Kyoya and Train(期望DP+Floyd+分治FFT)

    [Codeforces 553E]Kyoya and Train(期望DP+Floyd+分治FFT) 题面 给出一个\(n\)个点\(m\)条边的有向图(可能有环),走每条边需要支付一个价格\(c_i ...

随机推荐

  1. windows如何统计端口的连接数

    习惯了linux的系统管理员,对linux的命令行工具总是印象极深,几乎所有的管理都可以在命令行下完成.命令行工具是linux系统管理的主流. 而使用windows是,因为图形化的界面,大家习惯了图形 ...

  2. Redis系列(五)--主从复制

    单机环境存在的问题: 1.机器故障,直接凉凉 2.容量瓶颈 3.QPS瓶颈 主从复制 对于可拓展平台来说,复制(replication)是必不可少的.replication可以让其他服务器slave拥 ...

  3. wpf 界面加载 Command

    导入 xmlns:i="http://schemas.microsoft.com/expression/2010/interactivity" <i:Interaction. ...

  4. js中=,==,===的区别

    =      赋值 ==    先判断类型,在判断值,可以做类型转换 ===  恒等判断

  5. idea安装及使用

    使用:https://blog.csdn.net/qq_42303709/article/details/81983208 安装教程:https://blog.csdn.net/yl171272518 ...

  6. 浅析Oracle中的不等于号

    前几天碰到一个关于Oracle不等于的问题,最后搜索了一下,发现下面资料,拿来跟大家分享一下,需要的朋友可以参考下     关于Oracle中的不等于号: 在Oracle中, <> != ...

  7. 洛谷——P3389 【模板】高斯消元法

    P3389 [模板]高斯消元法 以下内容都可省略,直接转大佬博客%%% 高斯消元总结 只会背板子的蒟蒻,高斯消元是什么,不知道诶,看到大佬们都会了这个水题,蒟蒻只好也来切一切 高斯消元最大用途就是解多 ...

  8. 51nod 1050 循环数组最大子段和【动态规划】

    N个整数组成的循环序列a[1],a[2],a[3],-,a[n],求该序列如a[i]+a[i+1]+-+a[j]的连续的子段和的最大值(循环序列是指n个数围成一个圈,因此需要考虑a[n-1],a[n] ...

  9. vue子组件向父组件传递参数的基本方式

    子组件: this.$emit('transferUrl', this.picUrl) 父组件: 引入子组件<pics @transferUrl="gettransferUrl&quo ...

  10. 1.Linux标准IO编程

    1.1Linux系统调用和用户编程接口 1.1.1系统调用 用户程序向操作系统提出请求的接口.不同的系统提供的系统调用接口各不相同. 继承UNIX系统调用中最基本和最有用的部分. 调用按照功能分:进程 ...